#include <map>
#include <set>
#include <list>
#include <cmath>
#include <ctime>
#include <deque>
#include <queue>
#include <stack>
#include <string>
#include <bitset>
#include <cstdio>
#include <limits>
#include <vector>
#include <climits>
#include <cstring>
#include <cstdlib>
#include <fstream>
#include <numeric>
#include <sstream>
#include <cassert>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <fstream>
#include <unordered_map>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(),x.end()
#define pb push_back
#define ent "\n"

const int maxn = (int)1e6 + 13;
const ll inf = (long long)1e18 + 20;
const int mod = (int)1e9 + 7;
ld binpow (ld a, int n){
    if(n == 0){
        return 1;
    }
    if(n %  2 == 1){
        return (binpow(a,n - 1) * a);
    }
    ld h = binpow(a,n / 2);
    h *= h;
    return h;
}
pair < long double, long double > a[maxn];
long double ans[maxn];
void solve(){
    int n, m;
    cin >> n >> m;
    long double r, rr;
    cin >> r;
    rr = 1.0 - r;
    for (int i = 1; i <= n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    sort(a + 1, a + n + 1);
    for (int i = 1; i <= n; i++) {
        ans[i] = ans[i - 1] * binpow((1.0 - r), a[i].first - a[i - 1].first) + a[i].second * r;
    }
    while (m--) {
        int d;
        cin >> d;
        if(a[1].first > d){
            cout << "0.000000 ";
        }
        else if(a[n].first < d){
            cout << fixed << setprecision(6) << ans[n] * binpow((1.0 - r),d - a[n].first) << ' ';
        }
        else{
            int l = 1,r = n;
            int p = 0;
            while(l < r){
                int mid = (l + r + 1) / 2;
                if(a[mid].first <= d)l = mid;
                else r = mid - 1;
            }
            p = l;
            cout <<fixed << setprecision(6)<< ans[p] * binpow(rr, d - a[p].first) << " ";
        }
    }
}

int main(){
     ios_base::sync_with_stdio(0);
     cin.tie(0);
     int t = 1;
     //cin >> t;
     while(t --){
        solve();
     }
     return 0;
}
